--***************************************************************
--
-- load from central config file
-- 
-- version 1.3 by mogli (biedens)
-- 2014/08/06
--
--***************************************************************

local ModsDirectory  = g_modsDirectory.."/"

source(Utils.getFilename("mrGearboxMogli.lua", g_currentModDirectory))
--source(Utils.getFilename("mrGearboxXerion.lua", g_currentModDirectory))

mrGearboxMogliLoader = {}
mrGearboxMogliLoader.myCurrentModDirectory = g_currentModDirectory
mrGearboxMogliLoader.myModsDirectory       = g_modsDirectory.."/"

for _,funcName in pairs({ "delete", 
													"mouseEvent", 
													"keyEvent",
													"readStream", 
													"writeStream", 
													"update", 
													"updateTick", 
													"readUpdateStream", 
													"writeUpdateStream", 
													"draw", 
													"getSaveAttributesAndNodes", 
													"loadFromAttributesAndNodes",
													"realSetSpeedLevelLimit" }) do
	if      mrGearboxMogli  ~= nil and type(mrGearboxMogli[funcName])  == "function"
			and mrGearboxXerion ~= nil and typetype(mrGearboxXerion[funcName]) == "function" then
			
		mrGearboxMogliLoader[funcName] = function( self, ... )
			if type(self)=="table" then
				local state, result = nil, nil
				if self.mrGbMLGearbox1 then
					state, result = pcall(mrGearboxMogli[funcName], self, ...)
				elseif self.mrGbMLGearbox2 then
					state, result = pcall(mrGearboxXerion[funcName], self, ...)
				end
				if state then
					return result
				end
			end
		end
		
	elseif  mrGearboxMogli  ~= nil and type(mrGearboxMogli[funcName])  == "function" then
	
		mrGearboxMogliLoader[funcName] = function( self, ... )
			if type(self)=="table" then
				local state, result = nil, nil
				if self.mrGbMLGearbox1 then
					state, result = pcall(mrGearboxMogli[funcName], self, ...)
				end
				if state then
					return result
				end
			end
		end
		
	elseif  mrGearboxXerion ~= nil and type(mrGearboxXerion[funcName]) == "function" then
	
		mrGearboxMogliLoader[funcName] = function( self, ... )
			if type(self)=="table" then
				local state, result = nil, nil
				if self.mrGbMLGearbox2 then
					state, result = pcall(mrGearboxXerion[funcName], self, ...)
				end
				if state then
					return result
				end
			end
		end
		
	end
end

function mrGearboxMogliLoader.prerequisitesPresent(specializations) 
	return SpecializationUtil.hasSpecialization(RealisticMotorized, specializations) 
end 

function mrGearboxMogliLoader:load(xmlFile) 
	
	self.mrGbMLRealEngine     = false
	self.mrGbMLGearbox1       = false
	self.mrGbMLGearbox2       = false
	self.mrGbMLConfigFileName = Utils.removeModDirectory(self.configFileName);
	
	if not( self.isRealistic ) or self.customEnvironment == nil or self.mrGbMLConfigFileName == nil or self.mrGbMLConfigFileName == "" or self.realOldManualGearBoxPresent then
		print("Error -1: "..tostring(self.isRealistic).." "..tostring(self.customEnvironment).." "..tostring(self.mrGbMLConfigFileName).." "..tostring(self.realOldManualGearBoxPresent))
		return
	end
	
	if hasXMLProperty(xmlFile, "vehicle.realEngine#ratedRpm") then
		self.mrGbMLRealEngine = true
	else
		local state, message = pcall( mrGearboxMogliLoader.loadRealEngine, self )		
		if not state then
			print("Error 1 loading mrGearboxMogliLoader: "..tostring(message)) 
			self.mrGbMLRealEngine = false
		end
	end
		
	local state, message = pcall( mrGearboxMogliLoader.loadGearboxMogli, self )
	if not state then
		print("Error 3 loading mrGearboxMogliLoader: "..tostring(message)) 
		self.mrGbMLGearbox1 = false
	end
	
		--if not self.mrGbMLGearbox1 then
		--	local state, message = pcall( mrGearboxMogliLoader.loadGearboxXerion, self )
		--	if not state then
		--		print("Error 6 loading mrGearboxMogliLoader: "..tostring(message)) 
		--		self.mrGbMLGearbox2 = false
		--	end
		--end
end 

function mrGearboxMogliLoader.initXmlFiles()

	if mrGearboxMogliLoader.initXmlFilesDone then 
		return 
	end
	
	mrGearboxMogliLoader.initXmlFilesDone = true
		
	mrGearboxMogliLoader.configInt = {}
	mrGearboxMogliLoader.configExt = {}
	
	local file1 = mrGearboxMogliLoader.myCurrentModDirectory.."zzzMrGearboxAddonConfig.xml"
	if fileExists(file1) then	
		local xmlFile = loadXMLFile( "vehicles", file1, "vehicles" )
		mrGearboxMogliLoader.xmlFileInt = xmlFile
		
		i=0
		while true do
      local entry       = { xmlName = string.format("vehicles.vehicle(%d)", i) }
      entry.configFileName = getXMLString(xmlFile, entry.xmlName .. "#configFileName")
      if entry.configFileName == nil then
				break
			end
			print(string.format( "zzzMrGearboxAddon: found configuration for %s", entry.configFileName ))				
			table.insert( mrGearboxMogliLoader.configInt, entry )
			i = i + 1
		end
	end

	local file2 = mrGearboxMogliLoader.myModsDirectory.."zzzMrGearboxAddonConfig.xml"
	if fileExists(file2) then	
		local xmlFile = loadXMLFile( "vehicles", file2, "vehicles" )
		mrGearboxMogliLoader.xmlFileExt = xmlFile
		
		i=0
		while true do
      local entry       = { xmlName = string.format("vehicles.vehicle(%d)", i) }
      entry.configFileName = getXMLString(xmlFile, entry.xmlName .. "#configFileName")
      if entry.configFileName == nil then
				break
			end
			print(string.format( "zzzMrGearboxAddon: found external configuration for %s", entry.configFileName ))				
			table.insert( mrGearboxMogliLoader.configExt, entry )
			i = i + 1
		end
	end
end

function mrGearboxMogliLoader:loadGeneric( func, tagName, propName1, propName2 )
	mrGearboxMogliLoader.initXmlFiles()
	
	local xmlFile
	
	xmlFile = mrGearboxMogliLoader.xmlFileExt
	for _,entry in pairs(mrGearboxMogliLoader.configExt) do
		if      entry.configFileName == self.mrGbMLConfigFileName
				and ( propName1 ==nil or hasXMLProperty(xmlFile, entry.xmlName..propName1 )  
				   or propName2 ==nil or hasXMLProperty(xmlFile, entry.xmlName..propName2 ) ) then 
			local state, message = pcall( func, self, xmlFile, entry.xmlName )	
			if state then
				print(string.format( "zzzMrGearboxAddon: %s inserted into %s", tagName, self.mrGbMLConfigFileName ))
				return true
			else
				print("Error 4 loading mrGearboxMogliLoader: "..tostring(message)) 
			end
		end
	end
	
	xmlFile = mrGearboxMogliLoader.xmlFileInt
	for _,entry in pairs(mrGearboxMogliLoader.configInt) do
		if      entry.configFileName == self.mrGbMLConfigFileName
				and ( propName1 ==nil or hasXMLProperty(xmlFile, entry.xmlName..propName1 )  
				   or propName2 ==nil or hasXMLProperty(xmlFile, entry.xmlName..propName2 ) ) then 
			local state, message = pcall( func, self, xmlFile, entry.xmlName )	
			if state then
				print(string.format( "zzzMrGearboxAddon: %s inserted into %s", tagName, self.mrGbMLConfigFileName ))
				return true
			else
				print("Error 5 loading mrGearboxMogliLoader: "..tostring(message)) 
			end
		end
	end

	print(string.format( "zzzMrGearboxAddon: no configuration found for inserting %s into %s", tagName, self.mrGbMLConfigFileName ))
	return false
end


function mrGearboxMogliLoader:loadRealEngine()
	self.mrGbMLRealEngine = mrGearboxMogliLoader.loadGeneric( self, mrGearboxMogliLoader.loadRealEngine2, "realEngine",  ".realEngine#ratedRpm", ".realEngine#generateTorque" )
end

function mrGearboxMogliLoader:loadGearboxMogli()
	self.mrGbMLGearbox1 = mrGearboxMogliLoader.loadGeneric( self, mrGearboxMogliLoader.loadGearboxMogli2, "gearboxMogli",  ".gearboxMogli.gears.gear(0)#speed" )
end

function mrGearboxMogliLoader:loadGearboxXerion()
	self.mrGbMLGearbox2 = mrGearboxMogliLoader.loadGeneric( self, mrGearboxMogliLoader.loadGearboxXerion2, "gearboxXerion",  ".gearboxXerion#transmissionEfficiency" )
end

function mrGearboxMogliLoader:loadGearboxMogli2(xmlFile,baseName)	
	mrGearboxMogli.initFromXml( self, xmlFile, baseName .. ".gearboxMogli" )
end

function mrGearboxMogliLoader:loadGearboxXerion2(xmlFile,baseName)	
	--mrGearboxXerion.initFromXml( self, xmlFile, baseName .. ".gearboxXerion" )
end

function mrGearboxMogliLoader:loadRealEngine2(xmlFile,baseName)	

	if      hasXMLProperty( xmlFile, baseName..".realEngine#generateTorque" )
			and getXMLBool( xmlFile, baseName..".realEngine#generateTorque" ) then
		print(string.format("Calculating default torque curve for : %s", baseName))
		mrGearboxMogliLoader.calculateDefaultEngine(self,xmlFile,baseName)	
	elseif  hasXMLProperty( xmlFile, baseName..".realEngine.torque(0)#rpm" ) then
		mrGearboxMogliLoader.loadEngineCurve(self,xmlFile,baseName)	
	else
		return 1/0
	end
	
	if hasXMLProperty(xmlFile, baseName..".realEngine.pitch(0)#rpm") then	
		mrGearboxMogliLoader.loadPitchCurve(self,xmlFile,baseName)	
	else
	--print(string.format("Calculating default pitch curve for : %s", baseName))
		mrGearboxMogliLoader.calculateDefaultPitchCurve(self)	
	end
	
end

function mrGearboxMogliLoader:loadEngineCurve(xmlFile,baseName)	
	--**********************************************************************************************************************
	--20140218 - realEngine
	self.realEngine = {};
	self.realEngine.maxTorque = 0;
	self.realEngine.maxTorqueRpm = 0;
	self.realEngine.maxRpm = 0;
	self.realEngine.torqueCurve = AnimCurve:new(linearInterpolator1);
	self.realEngine.fuelUsageRatioCurve = AnimCurve:new(linearInterpolator1);
	local torqueI = 0;
	while true do
		local key = string.format(baseName..".realEngine.torque(%d)", torqueI);
		local rpm = getXMLFloat(xmlFile, key.."#rpm");
		local torque = getXMLFloat(xmlFile, key.."#ptoTorque");
		local fuelUsageRatio = getXMLFloat(xmlFile, key.."#fuelUsageRatio");
		if torque == nil or rpm == nil or fuelUsageRatio==nil then
			break;
		end;
		torque = torque / self.realPtoDriveEfficiency; -- take into account "realPtoDriveEfficiency" !!! => we are talking of the pto torque curve here.
		self.realEngine.torqueCurve:addKeyframe({v=torque, time = rpm});
		self.realEngine.fuelUsageRatioCurve:addKeyframe({v=fuelUsageRatio, time = rpm});
		
		if torque>self.realEngine.maxTorque then
			self.realEngine.maxTorqueRpm = rpm;
			self.realEngine.maxTorque = torque;
		end;
		
		self.realEngine.maxRpm = math.max(self.realEngine.maxRpm, rpm);
		torqueI = torqueI + 1;		
	end;
	
	self.realEngine.accelerationSpeed = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#accelerationSpeed"), self.maxAccelerationSpeed*1000)*0.001;
	self.realEngine.decelerationSpeed = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#decelerationSpeed"), self.decelerationSpeed*1000)*0.001;
	
	self.realEngine.speedLimiter = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#speedLimiter"),9999)/3.6; -- kph to mph

	self.realEngine.revUpTimeMs = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#revUpTimeMs"), 1400);
	self.realEngine.revDownTimeMs = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#revDownTimeMs"), 2000);
	
	self.realEngine.idleRpm = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#idleRpm"), 800);
	self.realEngine.ratedRpm = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#ratedRpm"), 2100);
	
	self.realEngine.idleRpmRatio = self.realEngine.idleRpm/self.realEngine.ratedRpm;
	self.realEngine.ratedToMaxRpmRatio = self.realEngine.maxRpm/self.realEngine.ratedRpm;
	self.realEngine.ratedToMaxTorqueRpmRatio = self.realEngine.maxRpm/self.realEngine.maxTorqueRpm;
	
	self.realEngine.currentGearRatedSpeed = 0;
	self.realEngine.ratedEngineRpmWheelSpeedRatio = 0;				
	self.realEngine.engineMaxTorqueToWheelPossible = 0;
		
end

function mrGearboxMogliLoader:loadPitchCurve(xmlFile,baseName)	
	self.realEngine.motorSoundPitchCurve = AnimCurve:new(linearInterpolator1);
	self.realEngine.motorSoundRunPitchCurve = AnimCurve:new(linearInterpolator1);
	local pitchI = 0;
	while true do
		local key = string.format(baseName..".realEngine.pitch(%d)", pitchI);
		local rpm = getXMLFloat(xmlFile, key.."#rpm");
		local pitch = getXMLFloat(xmlFile, key.."#motorSoundPitch");
		local pitchRun = getXMLFloat(xmlFile, key.."#motorSoundRunPitch");
		if pitch == nil or rpm == nil or pitchRun==nil then
			break;
		end;
		self.realEngine.motorSoundPitchCurve:addKeyframe({v=pitch, time = rpm});	
		self.realEngine.motorSoundRunPitchCurve:addKeyframe({v=pitchRun, time = rpm});	
		pitchI = pitchI + 1;
	end;
	
end

function mrGearboxMogliLoader:calculateDefaultEngine(xmlFile,baseName)	
	--**********************************************************************************************************************
	--20140218 - realEngine
	self.realEngine = {};
	self.realEngine.maxTorque = 0;
	self.realEngine.maxTorqueRpm = 0;
	self.realEngine.maxRpm = 0;
	self.realEngine.torqueCurve = AnimCurve:new(linearInterpolator1);
	self.realEngine.fuelUsageRatioCurve = AnimCurve:new(linearInterpolator1);
	self.realEngine.idleRpm = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#idleRpm"), 800);
	self.realEngine.ratedRpm = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#ratedRpm"), 2100);
	
	local torqueCurve = {}
	table.insert( torqueCurve, { rpm = 0   , torque = 0  , fuelUsageRatio = 1      } )
	table.insert( torqueCurve, { rpm = 800 , torque = 451, fuelUsageRatio = 0.929  } ) -- idle rpm
	table.insert( torqueCurve, { rpm = 1100, torque = 540, fuelUsageRatio = 0.909  } )
	table.insert( torqueCurve, { rpm = 1400, torque = 564, fuelUsageRatio = 0.911  } ) -- max torque 600 Nm
	table.insert( torqueCurve, { rpm = 1630, torque = 536, fuelUsageRatio = 0.928  } )
	table.insert( torqueCurve, { rpm = 1870, torque = 500, fuelUsageRatio = 0.960  } )
	table.insert( torqueCurve, { rpm = 2100, torque = 455, fuelUsageRatio = 1.000  } ) -- rated rpm:  144 PS = 100 kw @ PTO
	table.insert( torqueCurve, { rpm = 2150, torque = 427, fuelUsageRatio = 1.050  } )
	table.insert( torqueCurve, { rpm = 2200, torque = 227, fuelUsageRatio = 1.200  } )
	table.insert( torqueCurve, { rpm = 2250, torque = 73 , fuelUsageRatio = 1.45   } )
	table.insert( torqueCurve, { rpm = 2300, torque = 45 , fuelUsageRatio = 1.5    } )
	table.insert( torqueCurve, { rpm = 2350, torque = 23 , fuelUsageRatio = 1.55   } )
	table.insert( torqueCurve, { rpm = 2500, torque = 0  , fuelUsageRatio = 3      } )
	                                                                      	
	local factor = ( self.realEngine.ratedRpm - self.realEngine.idleRpm ) / 1300
	
	for i,entry in pairs(torqueCurve) do
		local torqueI = i-1;
		local rpm = ( entry.rpm - 800 ) * factor + self.realEngine.idleRpm
		local torque = entry.torque
		local fuelUsageRatio = entry.fuelUsageRatio
		torque = torque * self.realPower / 100
		self.realEngine.torqueCurve:addKeyframe({v=torque, time = rpm});
		self.realEngine.fuelUsageRatioCurve:addKeyframe({v=fuelUsageRatio, time = rpm});
		
	--print('<torque rpm"'..tostring(rpm)..'" torque="'..tostring(torque)..'" fuelUsageRatio="'..tostring(fuelUsageRatio)..'">')
		
		if torque>self.realEngine.maxTorque then
			self.realEngine.maxTorqueRpm = rpm;
			self.realEngine.maxTorque = torque;
		end;
		
		self.realEngine.maxRpm = math.max(self.realEngine.maxRpm, rpm);	
	end;

	self.realEngine.accelerationSpeed = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#accelerationSpeed"), self.maxAccelerationSpeed*1000)*0.001;
	self.realEngine.decelerationSpeed = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#decelerationSpeed"), self.decelerationSpeed*1000)*0.001;
	
	self.realEngine.speedLimiter = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#speedLimiter"),9999)/3.6; -- kph to mph

	self.realEngine.revUpTimeMs = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#revUpTimeMs"), 1400);
	self.realEngine.revDownTimeMs = Utils.getNoNil(getXMLFloat(xmlFile, baseName..".realEngine#revDownTimeMs"), 2000);
	
	self.realEngine.idleRpm = 800
	self.realEngine.ratedRpm = 2100
	
	self.realEngine.idleRpmRatio = self.realEngine.idleRpm/self.realEngine.ratedRpm;
	self.realEngine.ratedToMaxRpmRatio = self.realEngine.maxRpm/self.realEngine.ratedRpm;
	self.realEngine.ratedToMaxTorqueRpmRatio = self.realEngine.maxRpm/self.realEngine.maxTorqueRpm;
	
	self.realEngine.currentGearRatedSpeed = 0;
	self.realEngine.ratedEngineRpmWheelSpeedRatio = 0;				
	self.realEngine.engineMaxTorqueToWheelPossible = 0;
		
end	

function mrGearboxMogliLoader:calculateDefaultPitchCurve()	

	self.realEngine.motorSoundPitchCurve = AnimCurve:new(linearInterpolator1);
	self.realEngine.motorSoundRunPitchCurve = AnimCurve:new(linearInterpolator1);

	local p1 = Utils.getNoNil( self.motorSoundPitchOffset, 1)
	local p2 = Utils.getNoNil( self.motorSoundPitchMax   , 2) * 1.1 -- additional 10% because of self.realSoundSpdFx
	local p3 = Utils.getNoNil( self.motorSoundRunPitchOffset, 1)
	local p4 = Utils.getNoNil( self.motorSoundRunPitchMax, 2) * 1.1 -- additional 10% because of self.realSoundSpdFx
	local p5 = p2 + 0.077 * ( p2 - p1 )
	local p6 = p4 + 0.077 * ( p4 - p3 )
	local pitchCurve = {}	
	table.insert( pitchCurve, { rpm = 0.25 * self.realEngine.idleRpm, motorSoundPitch = 1.5*p1-0.5*p2, motorSoundRunPitch = 1.5*p3-0.5*p4 } )
	table.insert( pitchCurve, { rpm = self.realEngine.idleRpm       , motorSoundPitch = p1           , motorSoundRunPitch = p3            } )
	table.insert( pitchCurve, { rpm = self.realEngine.ratedRpm + 100, motorSoundPitch = p5           , motorSoundRunPitch = p6            } )
	table.insert( pitchCurve, { rpm = 15000                         , motorSoundPitch = 2*p2-p1      , motorSoundRunPitch = 2*p4-p3       } )

	for i,entry in pairs(pitchCurve) do
		local pitchI = i-1;
		local rpm = entry.rpm
		local pitch = entry.motorSoundPitch
		local pitchRun = entry.motorSoundRunPitch

	--print('<pitch: rpm="'..tostring(rpm)..'" motorSoundPitch="'..tostring(pitch)..'" motorSoundRunPitch="'..tostring(pitchRun)..'">')
		
		self.realEngine.motorSoundPitchCurve:addKeyframe({v=pitch, time = rpm});	
		self.realEngine.motorSoundRunPitchCurve:addKeyframe({v=pitchRun, time = rpm});	
	end;
	
	--** end realEngine
	--**********************************************************************************************************************		
end
